//
//  AppDelegate.m
//  CurlOperations
//
//  Created by Sample R on 11/01/13.
//  Copyright (c) 2013 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate
@synthesize objCurl;
@synthesize curlOperationThread;
@synthesize window = _window;


- (void)dealloc
{
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
}

-(IBAction)startTest:(id)sender
{
    
    
    NSString *BOUNDRY = [self generateBoundaryString];// This is important! //NSURLConnection is very sensitive to format.
//    NSString *tmpFilePath = @"/Volumes/Untitled/uploadTest.upload";
    NSString *tmpFilePath = @"/Volumes/Untitled/Sample.txt";
    NSData* d = [[NSData alloc]initWithContentsOfFile:tmpFilePath];
    
    NSString *uploadURL = @"DummyURL";
    NSMutableURLRequest *request = 
    [NSMutableURLRequest requestWithURL:[NSURL URLWithString:uploadURL]];
    [request setTimeoutInterval:4];
    [request setCachePolicy:NSURLRequestReloadIgnoringLocalCacheData];
    [request setHTTPMethod:@"POST"];
    [request setValue:
     [NSString stringWithFormat:@"multipart/form-data; boundary=%@", BOUNDRY]
   forHTTPHeaderField:@"Content-Type"];
    NSMutableData *postData =
    [NSMutableData dataWithCapacity:[d length] + 512];
    [postData appendData:
     [[NSString stringWithFormat:@"--%@\r\n", BOUNDRY] dataUsingEncoding:NSUTF8StringEncoding]];
    [postData appendData:
     [[NSString stringWithFormat:
       @"Content-Disposition: form-data; name=\"file\"; filename=\"%@\"\r\n\r\n", [tmpFilePath lastPathComponent]]
      dataUsingEncoding:NSUTF8StringEncoding]];
    [postData appendData:d];
    [postData appendData:
     [[NSString stringWithFormat:@"\r\n--%@--\r\n", BOUNDRY] dataUsingEncoding:NSUTF8StringEncoding]];
    [d release];
    [request setHTTPBody:postData];
    
    NSMutableDictionary *tmpDict = [NSMutableDictionary dictionary];
    [tmpDict setValue:request forKey:@"URLRequest"];

    self.curlOperationThread = [[[NSThread alloc] initWithTarget:self selector:@selector(startTask:) object:[NSDictionary dictionaryWithDictionary:tmpDict]] autorelease] ;
    [self.curlOperationThread start];
    
}

       
                                
-(IBAction)cancelTest:(id)sender
{
        NSLog(@"Current operation cancelled");
        [self.objCurl cancel];
}

- (void)startTask:(id)object {
    
    NSAutoreleasePool	*pool	= [[NSAutoreleasePool alloc]init];
    
    NSDictionary *dict = [NSDictionary dictionaryWithDictionary:object];
    NSMutableURLRequest *requestt = [dict objectForKey:@"URLRequest"];

    CURLHandle *tmpp = [[CURLHandle alloc] init] ;
    [tmpp setDelegate:self];
    self.objCurl = tmpp;
    [tmpp release];
    NSError *errorrr = nil;
    if([tmpp loadRequest:requestt error:&errorrr] == NO)
    {
        NSLog(@"Operation failed. Error = %@", [errorrr localizedDescription]);
    }
    else {
        NSLog(@"Operation successful");
    }

    NSLog(@"Async operation completed");
    [pool drain];
}

-(IBAction)startDownloadTest:(id)sender
{
    NSString *downloadURL = nil;
    NSURL *url = [NSURL URLWithString:downloadURL];
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    [request setCachePolicy:NSURLRequestReloadIgnoringLocalCacheData];
    [request setTimeoutInterval:6];
    NSMutableDictionary *tmpDict = [NSMutableDictionary dictionary];
    [tmpDict setValue:request forKey:@"URLRequest"];
    
    self.curlOperationThread = [[[NSThread alloc] initWithTarget:self selector:@selector(startTask:) object:[NSDictionary dictionaryWithDictionary:tmpDict]] autorelease] ;
    [self.curlOperationThread start];

}



- (NSString *)generateBoundaryString
{
    CFUUIDRef       uuid;
    CFStringRef     uuidStr;
    NSString *      result;
    
    uuid = CFUUIDCreate(NULL);
    assert(uuid != NULL);
    
    uuidStr = CFUUIDCreateString(NULL, uuid);
    assert(uuidStr != NULL);
    
    result = [NSString stringWithFormat:@"Boundary-%@", uuidStr];
    
    CFRelease(uuidStr);
    CFRelease(uuid);
    
    return result;
}


- (void)handle:(CURLHandle *)handle didReceiveData:(NSData *)data
{
    NSLog(@"Received data of size %ld", [data length]);
}
//@optional
- (void)handle:(CURLHandle *)handle didReceiveResponse:(NSURLResponse *)response
{
    NSHTTPURLResponse * httpResponse = (NSHTTPURLResponse *) response;
    //    NSLog(@"%ld connection: Recieved response code %@",(long)objectRefID, [NSString stringWithFormat:@"HTTP error %zd", (ssize_t) httpResponse.statusCode]);
    //  NSLog(@"UploadCtrl:Recieved response code %ld.",(long)httpResponse.statusCode);
    if ((httpResponse.statusCode / 100) == 2) 
    {
        NSLog(@"Response code 200 recieved");// download initiated.
    }
    else {
        NSLog(@"UploadCtrl:Recieved response code %ld.",(long)httpResponse.statusCode);// report download failure.
    }
    
}

// When sending data to the server, this reports just before it goes out on the wire. Reports a length of 0 when the end of the data is written so you can get a nice heads up that an upload is about to complete
- (void)handle:(CURLHandle *)handle willSendBodyDataOfLength:(NSUInteger)bytesWritten
{
    static int totalBytes = 0;
    // no. of bytes uploaded.
    NSLog(@"Written data of length %ld. total bytes %ld", bytesWritten, totalBytes);
    totalBytes = bytesWritten + totalBytes;
    if(bytesWritten == 0)
    {
        NSLog(@"Upload process completed");// indicates upload was successful and complete. but wait for 200 to report operation completed.
    }
}

- (void)handle:(CURLHandle *)handle didReceiveDebugInformation:(NSString *)string ofType:(curl_infotype)type
{
        NSLog(@"Debug info = %@ curl type = %ld", string, type);
}

@end
